var canvas, ctx;
canvas = document.getElementById('drawing');
ctx = canvas.getContext('2d');

var p = false;
// Для поворота относительно произвольной точки - подставить A и B:
// p = {x: A, y: B};

var startTime;
var Idint;

var objs = new Array();
var clicked = new Set();

addEventListener("keydown", buttonPress);
addEventListener("keyup", buttonUp);

function buttonPress(event){
  //console.log(event.code);
  clicked.add(event.code);
}
function buttonUp(event){
  clicked.delete(event.code);
}

function resetCanv(){
  init();
}


class shape{
  startPos = {x:0, y:0}; h = 0; w = 0;
  angle; rotateSpeed; speed; scaleSpeed;   stepSpeed;
  standartScale = 1; toWindowScale = 1; scale = 1;
  points = new Array();
  standartCanvWidth; standartCanvHeight;
  min_point = {x:0, y: 0}; max_point = {x:0, y: 0}; center_point = {x: 0, y: 0};
  isSelect = false; isWindowScale = false;
  pivot_point;

  constructor(x = 0, y = 0, angle = 0, speed = 0, stepSpeed = 0, rotateSpeed = 0, scaleSpeed = 0, standartCanvWidth = 600, standartCanvHeight = 600, pivot_point = false){
    this.startPos.x = x; this.startPos.y = y; this.angle = angle;
    this.rotateSpeed = rotateSpeed; this.scaleSpeed = scaleSpeed; this.speed = speed; this.stepSpeed = stepSpeed;
    this.min_point = {x: x, y: y}; this.max_point = {x: x, y: y};
    this.center_point = {x: x, y: y}; 
    if(pivot_point == false) this.pivot_point = this.center_point;
    else { this.pivot_point = pivot_point; }
    this.standartCanvWidth = standartCanvWidth, this.standartCanvHeight = standartCanvHeight;
  }
  
  copyFrom(item){
    for(let key in item){
      this[key] = item[key];
    }
    this.startPos = {x:item.startPos.x, y:item.startPos.y}
    this.min_point = {x: item.min_point.x, y:item.min_point.y};
    this.max_point = {x: item.max_point.x, y:item.max_point.y};
    this.center_point = {x: item.center_point.x, y: item.center_point.y}
    this.isSelect = false;    
    
    this.points = new Array();
    for(let i = 0; i < item.points.length; i++){
      this.points[i] = {x: 0, y:0, style:"", color:"", addition:""};
      for(let key in item.points[i]){
        this.points[i][key] = item.points[i][key];
      }
    }         
  }
  
  updateCenterPoint(){
    this.center_point.x = (this.min_point.x + this.max_point.x) / 2;
    this.center_point.y = (this.min_point.y + this.max_point.y) / 2;
  }
  

  newPoint(x1, y1, style = "lineTo", color = "black",  addition = false){
    x1 += this.startPos.x; y1 += this.startPos.y;         
    this.points.push({x: x1, y: y1, style: style, color: color,  addition: addition});
    if(style != "fill" && style != "fillStyle" && style != "stroke" && style != "strokeStyle" && style != "linearGradieng" && style != "radialGradient" && style != "beginPath" && style != "closePath"){
      this.min_point = {x: Math.min(this.min_point.x, x1), y: Math.min(this.min_point.y, y1)};
      this.max_point = {x: Math.max(this.max_point.x, x1), y: Math.max(this.max_point.y, y1)};
    }    
    this.updateCenterPoint();
    
  }
  
  deletePoint(ind){
    if (ind >= this.points.length) return;
    this.toStandartScale();
    this.points.splice(ind, 1);
    this.updateMinMaxCoords(); this.updateCenterPoint();
    this.scaleToWindow();
  }
  
  updateMinMaxCoords(){
    if (this.points.length == 0) return;
    
    for(let i = 0; i < this.points.length; i++){
      let style = this.points[i].style;
      if(style != "fill" && style != "fillStyle" && style != "stroke" && style != "strokeStyle" && style != "linearGradieng" && style != "radialGradient" && style != "beginPath" && style != "closePath"){
        this.min_point.x = this.points[i].x; this.max_point.x = this.points[i].x;
        this.min_point.y = this.points[i].y; this.max_point.y = this.points[i].y;
        break;
      }
    }
    for(let point of this.points){
      let style = point.style;
      if(style != "fill" && style != "fillStyle" && style != "stroke" && style != "strokeStyle" && style != "linearGradieng" && style != "radialGradient" && style != "beginPath" && style != "closePath"){
        if (point.x < this.min_point.x) this.min_point.x = point.x;
        if (point.x > this.max_point.x) this.max_point.x = point.x;
        if (point.y < this.min_point.y) this.min_point.y = point.y;
        if (point.y > this.max_point.y) this.max_point.y = point.y;
       }
    }
    this.h = this.max_point.y - this.min_point.y;
    this.w = this.max_point.x - this.min_point.x;
  }
  
  toStandartScale(){
    this.changeScale(1 / this.toWindowScale);
    this.speed /= this.toWindowScale; this.stepSpeed /= this.toWindowScale;
    
    if(this.pivot_point != this.center_point)
    { this.pivot_point.x /= this.toWindowScale; this.pivot_point.y /= this.toWindowScale; }
     this.isWindowScale = false;
  }
  
  scaleToWindow(){   

    let sx = -1, sy = -1;
    if (this.max_point.x - this.min_point.x == 0 && this.max_point.y - this.min_point.y == 0) return;
    if (this.max_point.x - this.min_point.x != 0) sx = canvas.width / (this.max_point.x - this.min_point.x);
    if (this.max_point.y - this.min_point.y != 0) sy = canvas.height / (this.max_point.y - this.min_point.y);
    this.standartScale = Math.min(this.standartCanvWidth / (this.max_point.x - this.min_point.x), this.standartCanvHeight / (this.max_point.y - this.min_point.y));
    
    let realScale;
    if(sx == -1 || sy == -1) realScale = Math.max(sx, sy);
    else realScale = Math.min(sx, sy);
    
    let k = realScale / this.standartScale;
    this.toWindowScale = k;
    this.changeScale(k);
    this.speed *= k; this.stepSpeed *= k;
    if(this.pivot_point != this.center_point)
    { this.pivot_point.x *= k; this.pivot_point.y *= k;}
    this.isWindowScale = true;
  }
  
  outOfCanv(){
    if((this.max_point.x - this.min_point.x > canvas.width) || (this.max_point.y - this.min_point.y > canvas.height)) return "type1";
    if(this.min_point.x < 0 || this.min_point.y < 0 || this.max_point.x > canvas.width || this.max_point.y > canvas.height) return "type2";
    return false;
  }
  
  repairMinMax(){
    let dx = 0, dy = 0;
    if (this.min_point.x < 0) dx += -this.min_point.x;
    if (this.min_point.y < 0) dy += -this.min_point.y;
    if (this.max_point.x > canvas.width) dx += canvas.width - this.max_point.x;
    if (this.max_point.y > canvas.height) dy += canvas.height - this.max_point.y;
    this.move(dx, dy);
  }
  
  move(dx, dy, time = 1){
    this.center_point.x += dx*time;
    this.center_point.y += dy*time;
    for(let point of this.points){
      point.x+=dx*time;
      point.y+=dy*time;  
    }
    this.updateMinMaxCoords();
    if(this.outOfCanv()) this.move(-dx, -dy, time);
  }
  
  moveTo(x, y, time = 1){
    let dx = x - this.min_point.x;
    let dy = y - this.min_point.y;
    this.center_point.x += dx*time;
    this.center_point.y += dy*time;
    for(let point of this.points){
      point.x+=dx*time;
      point.y+=dy*time;  
    }
    this.updateMinMaxCoords();
    if(this.outOfCanv()) this.move(-dx, -dy, time);
  }
  
  changeRotate(angle, time = 1, center_x = this.center_point.x, center_y = this.center_point.y){

    let isBad = false;
    if(this.outOfCanv()) isBad = true;
    
    this.angle += angle*time;
    
    for(let point of this.points){
     point.x -= center_x;  point.y -= center_y;
     let tmp = {x: point.x, y: point.y};
     point.x=tmp.x*Math.cos(angle*time)-tmp.y*Math.sin(angle*time);
     point.y=tmp.x*Math.sin(angle*time)+tmp.y*Math.cos(angle*time);
     point.x += center_x; point.y += center_y;
    }
    
    this.updateCenterPoint();
    this.updateMinMaxCoords();
    if(isBad) this.repairMinMax();
    if(this.outOfCanv()) this.changeRotate(-angle, time, center_x, center_y);
  }
  
  changeScale(scale, time = 1){
    let k = 1 + time*(scale -  1);
    if(k == 0) return;
    
    this.scale *= k;
    for(let point of this.points){
       point.x -= this.center_point.x;  point.y -= this.center_point.y;
       let tmp = {x: point.x, y: point.y};
       point.x *= k;
       point.y *= k;
       point.x += this.center_point.x; point.y += this.center_point.y;
    }
    this.updateMinMaxCoords();
    if(this.outOfCanv() == "type1") this.changeScale((1 - k) / (time * k) + 1, time);
    else this.repairMinMax(time);
  }
  
  drawShape(){

    let fillStyle = "black", strokeStyle = "black";
    this.points.forEach(function(item, i, array){
      switch(item.style){
        case 'beginPath':
          ctx.beginPath();
          break;
        case 'closePath':
          ctx.closePath();
          break;
        case 'lineTo':
          ctx.lineTo(item.x, item.y);
          break;
        case 'moveTo':
          ctx.moveTo(item.x, item.y);
          break;
        case 'fillStyle':
          fillStyle = item.color;
          break;
        case 'strokeStyle':
          strokeStyle = item.color;
          ctx.stroke();
        case 'fill':
          ctx.fillStyle = fillStyle;
          ctx.fill();
          break;
        case 'stroke':
          ctx.strokeStyle = strokeStyle;
          ctx.stroke();
          break;
        case 'quadraticCurveTo':
          ctx.quadraticCurveTo(array[i+1].x, array[i+1].y, item.x, item.y);
          break;
        case 'bezierCurveTo':
          ctx.quadraticCurveTo(array[i+1].x, array[i+1].y, array[i+2].x, array[i+2].y, item.x, item.y);
          break;
        /*
        case 'radialGradient':
          fillStyle = ctx.createRadialGradient(item.x, item.y, item.addition, array[i+1].x, array[i+1].y, array[i+1].addition);
        */
           break;
        case 'linearGradient':
          fillStyle = ctx.createLinearGradient(item.x, item.y, array[i+1].x, array[i+1].y);
          break;
        case 'addColorStop':
          fillStyle.addColorStop(item.addition, item.color);
        case 'used':
          break;
      };
    });
  }
  
  update(time){
    
    if(!this.isWindowScale){ this.scaleToWindow(); this.moveTo(this.startPos.x, this.startPos.y) }
    if(this.outOfCanv()) this.repairMinMax();
    
    let dx = 0, dy = 0;
    let dAngle = 0; let dScale = 1;
    let newRotate = 0;
    let n = 0;

    if(this.isSelect){
      for(let key of clicked){
        if(key=='KeyW' || key=='ArrowUp'){
          dy += -this.speed;
          newRotate += -Math.PI / 2;
          n += 1;
        }
        if(key=='KeyS' || key=='ArrowDown'){
          dy += this.speed;
          newRotate += -3 * Math.PI / 2;
          n += 1;
        }
        if(key=='KeyA' || key=='ArrowLeft'){
          dx += -this.speed;
          newRotate += -Math.PI;
          n += 1;
        }
        if(key=='KeyD' || key=='ArrowRight'){
          dx += this.speed;
          newRotate += 0;
          n += 1;
        }
        if(key=='KeyQ'){
          dAngle += -this.rotateSpeed;
        }
        if(key=='KeyE'){
          dAngle += this.rotateSpeed;
        }
        if (key=='NumpadAdd' || key=='Equal'){
          dScale *= this.scaleSpeed;
        }
        if (key=='NumpadSubtract' || key=='Minus'){
          dScale /= this.scaleSpeed;
        }
      }
    }
    //console.log(this.pivot_point)
    if (clicked.has('KeyD') && clicked.has('KeyS')) newRotate += -2 * Math.PI;

    this.move(dx, dy, time);
    this.changeRotate(dAngle, time, this.pivot_point.x, this.pivot_point.y);
    this.changeScale(dScale, time);
    if(n != 0) this.changeRotate(newRotate / n - this.angle);
  }
}


function init(){

  time = 0;
  objs = [];
  
  let speed = 100, stepSpeed = 25, rotateSpeed = Math.PI/2, scaleSpeed = 2, standartCanvWidth = 600, standartCanvHeight = 600;

  car = new shape(canvas.width/3, canvas.height/4, 0, speed, stepSpeed, rotateSpeed,scaleSpeed,standartCanvWidth, standartCanvHeight, p);
  
  // body
  car.newPoint(0, 0, "beginPath");
  car.newPoint(5, 0, "moveTo");
  
  car.newPoint(12, 0, "quadraticCurveTo");
  car.newPoint(6, -0.5, "used");
  car.newPoint(30, 0, "quadraticCurveTo");
  car.newPoint(21, 0.5, "used");
  car.newPoint(36, 0, "quadraticCurveTo");
  car.newPoint(33, -0.5, "used");  

  car.newPoint(40, 4, "quadraticCurveTo");
  car.newPoint(39, 2, "used");

  car.newPoint(40,3.7,"moveTo");
  car.newPoint(40, 12.3, "quadraticCurveTo");
  car.newPoint(41, 8, "used");  
  
  car.newPoint(40, 12, "lineTo");
  car.newPoint(36, 16, "quadraticCurveTo");
  car.newPoint(39, 14, "used");

  car.newPoint(30, 16, "quadraticCurveTo");
  car.newPoint(33, 16.5, "used");
  car.newPoint(12, 16, "quadraticCurveTo");
  car.newPoint(21, 15.5, "used");
  car.newPoint(5, 16, "quadraticCurveTo");
  car.newPoint(6, 16.5, "used");
  
  car.newPoint(5, 16, "lineTo");
  car.newPoint(0, 12, "quadraticCurveTo");
  car.newPoint(1, 15, "used");
  car.newPoint(0, 4, "lineTo");
  car.newPoint(5, 0, "quadraticCurveTo");
  car.newPoint(1, 1, "used");
  
  car.newPoint(0,0, "fillStyle", "rgb(154,202,122)");
  car.newPoint(0,0, "fill");
  car.newPoint(0, 0, "closePath");
  
  // color body
  car.newPoint(0, 0, "beginPath");
  car.newPoint(11,3.5,"moveTo");
  car.newPoint(11, 12.5, "quadraticCurveTo");
  car.newPoint(10, 8, "used");
  car.newPoint(14, 13, "quadraticCurveTo");
  car.newPoint(12, 13, "used");
  car.newPoint(14,13,"lineTo");
  car.newPoint(21,13,"lineTo");
  car.newPoint(27,14,"lineTo");
  car.newPoint(39, 13, "quadraticCurveTo");
  car.newPoint(39, 15, "used");
  
  car.newPoint(40,12.3,"lineTo");
  car.newPoint(40, 3.7, "quadraticCurveTo");
  car.newPoint(41, 8, "used");  
  car.newPoint(40,4,"lineTo");
  
  car.newPoint(39,3,"lineTo");
  car.newPoint(27, 2, "quadraticCurveTo");
  car.newPoint(39, 1, "used");
  car.newPoint(14,3,"lineTo");
  car.newPoint(11, 3.5, "quadraticCurveTo");
  car.newPoint(12, 3, "used");
  car.newPoint(0,0,"fillStyle", "rgb(131,183,98)");
  car.newPoint(0,0,"fill");
  
  // color back
  car.newPoint(0, 0, "beginPath");
  car.newPoint(5,13,"moveTo");
  car.newPoint(0, 12, "quadraticCurveTo");
  car.newPoint(3, 13, "used");
  car.newPoint(0,4,"lineTo");
  car.newPoint(5, 3, "quadraticCurveTo");
  car.newPoint(3, 3, "used");
  car.newPoint(0,0,"fillStyle", "rgb(131,183,98)");
  car.newPoint(0,0,"fill");
  
  // color lines back
  
  car.newPoint(0, 0, "beginPath");
  car.newPoint(1,2.3,"moveTo");
  car.newPoint(19, 1, "quadraticCurveTo");
  car.newPoint(3, 0, "used");
  car.newPoint(1, 2.3, "quadraticCurveTo");
  car.newPoint(4, 1, "used");  
  car.newPoint(0,0,"fillStyle", "rgb(131,183,98)");
  car.newPoint(0,0,"fill");
  
  car.newPoint(0, 0, "beginPath");
  car.newPoint(1,13.7,"moveTo");
  car.newPoint(19, 15, "quadraticCurveTo");
  car.newPoint(3, 16, "used");
  car.newPoint(1, 13.7, "quadraticCurveTo");
  car.newPoint(4, 15, "used");  
  car.newPoint(0,0,"fillStyle", "rgb(131,183,98)");
  car.newPoint(0,0,"fill");  
  
  // color lines front
  
  car.newPoint(0, 0, "beginPath");
  car.newPoint(40,4.5,"moveTo");
  car.newPoint(30, 3.5, "quadraticCurveTo");
  car.newPoint(37, 4.5, "used");
  car.newPoint(40, 5, "quadraticCurveTo");
  car.newPoint(37, 5, "used");
  car.newPoint(0,0,"fillStyle", "rgb(154,202,122)");
  car.newPoint(0,0,"fill");
 
  car.newPoint(0, 0, "beginPath");
  car.newPoint(40,11.5,"moveTo");
  car.newPoint(30, 12.5, "quadraticCurveTo");
  car.newPoint(37, 11.5, "used");
  car.newPoint(40, 11, "quadraticCurveTo");
  car.newPoint(37, 11, "used");
  car.newPoint(0,0,"fillStyle", "rgb(154,202,122)");
  car.newPoint(0,0,"fill");
  

  
  // glass
  car.newPoint(0, 0, "beginPath");
  car.newPoint(10,2,"moveTo");
  car.newPoint(27,2,"lineTo");
  car.newPoint(21,3,"lineTo");
  car.newPoint(14,3,"lineTo");
  car.newPoint(10, 2, "quadraticCurveTo");
  car.newPoint(12, 3, "used");
  car.newPoint(0,0, "fillStyle", "rgb(53,53,53)");
  car.newPoint(0,0, "fill");
  car.newPoint(0, 0, "closePath");
  
  car.newPoint(0, 0, "beginPath");
  car.newPoint(10,14,"moveTo");
  car.newPoint(27,14,"lineTo");
  car.newPoint(21,13,"lineTo");
  car.newPoint(14,13,"lineTo");
  car.newPoint(10, 14, "quadraticCurveTo");
  car.newPoint(12, 13, "used");
  car.newPoint(0,0, "fillStyle", "rgb(53,53,53)");
  car.newPoint(0,0, "fill");
  car.newPoint(0, 0, "closePath");

  // front
  car.newPoint(0, 0, "beginPath");
  car.newPoint(21,3.5,"moveTo");
  car.newPoint(28.5,2,"lineTo");
  car.newPoint(28.5, 14, "quadraticCurveTo");
  car.newPoint(29.5, 8, "used");
  car.newPoint(21,12.5,"lineTo");
  car.newPoint(21, 3.5, "quadraticCurveTo");
  car.newPoint(22, 8, "used");

  car.newPoint(21, 10, "linearGradient");
  car.newPoint(27, 10, "used");
  car.newPoint(0, 0, "addColorStop", "rgb(130,130,130)", 1);
  car.newPoint(0, 0, "addColorStop", "rgb(53,53,53)", 0);
  car.newPoint(0,0, "fill");
  car.newPoint(0, 0, "closePath");
  
  // back
  car.newPoint(0, 0, "beginPath");
  car.newPoint(11,3.5,"moveTo");
  car.newPoint(11, 12.5, "quadraticCurveTo");
  car.newPoint(10, 8, "used");
  car.newPoint(5,13,"lineTo");
  car.newPoint(5, 3, "quadraticCurveTo");
  car.newPoint(4, 8, "used");
  
  car.newPoint(10, 10, "linearGradient");
  car.newPoint(3, 10, "used");
  car.newPoint(0, 0, "addColorStop", "rgb(53,53,53)", 0);
  car.newPoint(0, 0, "addColorStop", "rgb(130,130,130)", 1);
  car.newPoint(0,0, "fill");
  car.newPoint(0, 0, "closePath");
  car.newPoint(0,0, "fill");
  car.newPoint(0, 0, "closePath");
  
  
  //lamp_l
  car.newPoint(0, 0, "beginPath");
  car.newPoint(36,0,"moveTo");
  car.newPoint(40,4,"quadraticCurveTo");
  car.newPoint(35,2,"used");
  car.newPoint(36,0,"quadraticCurveTo");
  car.newPoint(39,1,"used");

  car.newPoint(0,0,"strokeStyle", "rgb(130,130,130)")
  car.newPoint(0,0,"fillStyle", "rgb(71,71,71)");
  car.newPoint(0,0,"stroke");
  car.newPoint(0,0,"fill");

  
  //lamp_r
  car.newPoint(0, 0, "beginPath");
  car.newPoint(36,16,"moveTo");
  car.newPoint(40,12,"quadraticCurveTo");
  car.newPoint(35,14,"used");
  car.newPoint(36,16,"quadraticCurveTo");
  car.newPoint(39,15,"used");
  car.newPoint(0,0,"strokeStyle", "rgb(130,130,130)")
  car.newPoint(0,0,"fillStyle", "rgb(71,71,71)");
  car.newPoint(0,0,"stroke");
  car.newPoint(0,0,"fill");
  
  
  //stop_l 
  car.newPoint(0, 0, "beginPath");
  car.newPoint(0,4,"moveTo");
  car.newPoint(3.5,0.55,"quadraticCurveTo");
  car.newPoint(0,2.5,"used");
  car.newPoint(0,5,"quadraticCurveTo");
  car.newPoint(0.5,3,"used");  
  car.newPoint(0,0,"fillStyle", "red");  
  car.newPoint(0,0,"fill");
  
  //stop_r
  car.newPoint(0, 0, "beginPath");
  car.newPoint(0,12,"moveTo");
  car.newPoint(3.5,15.45,"quadraticCurveTo");
  car.newPoint(0,13.5,"used");
  car.newPoint(0,11,"quadraticCurveTo");
  car.newPoint(0.5,13,"used");
  car.newPoint(0,0,"fillStyle", "red");
  car.newPoint(0,0,"fill");
  
  // mirror_r
  
  car.newPoint(0, 0, "beginPath");
  car.newPoint(25.5,14,"moveTo");
  car.newPoint(27.5,14,"quadraticCurveTo");
  car.newPoint(24,17,"used");  
  car.newPoint(0,0,"fillStyle", "rgb(53,53,53)");
  car.newPoint(0,0,"fill");
  
  car.newPoint(0, 0, "beginPath");
  car.newPoint(25.8,14.2,"moveTo");
  car.newPoint(27,14.2,"quadraticCurveTo");
  car.newPoint(24.3,16.5,"used");  
  car.newPoint(0,0,"fillStyle", "rgb(124,164,142)");
  car.newPoint(0,0,"fill");
  
    // mirror_l
  
  car.newPoint(0, 0, "beginPath");
  car.newPoint(25.5,2,"moveTo");
  car.newPoint(27.5,2,"quadraticCurveTo");
  car.newPoint(24,-1,"used");  
  car.newPoint(0,0,"fillStyle", "rgb(53,53,53)");
  car.newPoint(0,0,"fill");
  
  car.newPoint(0, 0, "beginPath");
  car.newPoint(25.8,1.8,"moveTo");
  car.newPoint(27,1.8,"quadraticCurveTo");
  car.newPoint(24.3,-0.5,"used");  
  car.newPoint(0,0,"fillStyle", "rgb(124,164,142)");
  car.newPoint(0,0,"fill");
  car.scaleToWindow();  
  
  car.changeScale(4);
  objs.push(car);

  
  car.isSelect = true;
}

function clear(){
  ctx.fillStyle = "white";
  ctx.fillRect(0,0,ctx.canvas.width, ctx.canvas.height);
}


function draw(){
  clear();
  var endTime = Date.now();
  time = (endTime - startTime) / 800;

  for(let obj of objs){
     obj.update(time);
  }
  for(let obj of objs){
     obj.drawShape();
  }
  
  Idint = requestAnimationFrame(draw);
  startTime = endTime;
}

init();
startTime = Date.now();
Idint = requestAnimationFrame(draw);